%{
#include <string.h>
#include <stdlib.h>
#include "y.tab.h"
%}

%x NVAR OBJET METHODE OUVRE OUVRE2 PARAM FERME FERME2 SUIVANT ERREUR

eol         (\r\n)|(\n\r)|\r|\n
spaces      [ \t]+
commentaire \/\/.*
image       Image
var         [a-z_A-Z][a-z_A-Z0-9]*
obj         \.
ouv         \(\"
ferm        \"\)
parametre   [^\"\(\)]+
sep         {spaces}?{commentaire}?{eol}

%%
<INITIAL,NVAR>{spaces}  { /* ignored */ }
<INITIAL>{commentaire}  { BEGIN(SUIVANT); /* ignored */ }
<INITIAL>{eol}  { /* ignored */ }
<INITIAL>{image}  { BEGIN(NVAR); return tokImg; }
<NVAR>{var}  { strcpy(yylval.texte,yytext); BEGIN(SUIVANT); return tokNVAR; }
<INITIAL>{var}  { strcpy(yylval.texte,yytext); BEGIN(OBJET); return tokVariable; }
<OBJET>{obj}  { BEGIN(METHODE); }
<METHODE>loadFromFile  { BEGIN(OUVRE); return tokOuvrir; }
<METHODE>saveToFile  { BEGIN(OUVRE); return tokSauver; }
<METHODE>free  { BEGIN(OUVRE2); return tokFermer; }
<METHODE>ImgClearBorder  { BEGIN(OUVRE2); return tokImgClearBorder; }
<METHODE>ImgEqual  { BEGIN(OUVRE); return tokImgEqual; }
<METHODE>ImgNot  { BEGIN(OUVRE2); return tokImgNot; }
<METHODE>ImgBitNot  { BEGIN(OUVRE2); return tokImgBitNot; }
<METHODE>ImgAnd  { BEGIN(OUVRE); return tokImgAnd; }
<METHODE>ImgBitAnd  { BEGIN(OUVRE); return tokImgBitAnd; }
<METHODE>ImgBitOr  { BEGIN(OUVRE); return tokImgBitOr; }
<METHODE>ImgCountObjects  { BEGIN(OUVRE2); return tokImgCountObjects; }
<METHODE>ImgThin  { BEGIN(OUVRE2); return tokImgThin; }
<METHODE>ImgThicken  { BEGIN(OUVRE2); return tokImgThicken; }
<METHODE>ImgThinSkeleton  { BEGIN(OUVRE2); return tokImgThinSkeleton; }
<OUVRE>{ouv}  { BEGIN(PARAM); }
<OUVRE2>\(  { BEGIN(FERME2); }
<PARAM>{parametre}  { strcpy(yylval.texte,yytext); BEGIN(FERME); return tokParam; }
<FERME>{ferm}  { BEGIN(SUIVANT); }
<FERME2>\)  { BEGIN(SUIVANT); }
<SUIVANT>{sep}  { BEGIN(INITIAL); }
<INITIAL,NVAR,OBJET,METHODE,OUVRE,OUVRE2,PARAM,FERME,FERME2,SUIVANT>.  { BEGIN(ERREUR); yyerror("lex: erreur de syntaxe"); }
<ERREUR>.*  { BEGIN(SUIVANT); }
%%
