%{
#include <stdio.h>
#include "alexpierre.h"
#include "listeImages.h"
%}

%union
{
  int value;
  char texte[255];
}

%token <texte> tokVariable
%token <texte> tokParam
%token tokOuvrir
%token tokSauver
%token tokFermer
%token tokImgClearBorder
%token tokImgEqual
%token tokImgNot
%token tokImgBitNot
%token tokImgAnd
%token tokImgBitAnd
%token tokImgOr
%token tokImgBitOr
%token tokImgCountObjects
%token tokImgThin
%token tokImgThicken
%token tokImgThinSkeleton
%token tokImg
%token <texte> tokNVAR

%%

FICHIER:NV_IMG FICHIER
  | APPEL FICHIER
  |
  ;

NV_IMG:tokImg tokNVAR { printf("yacc: dclaration d'une nouvelle image '%s'\n",$2); ajoutImage($2); }
  ;

APPEL:tokVariable tokOuvrir tokParam { printf("yacc: ImRead '%s' sur '%s'\n",$3,$1); images[indexOfImage($1)]=ImRead($3); }
  | tokVariable tokSauver tokParam { printf("yacc: ImWriteAsc '%s' sur '%s'\n",$3,$1); ImWriteAsc(images[indexOfImage($1)],$3); }
  | tokVariable tokFermer { printf("yacc: ImFree '%s'\n",$1); libereImage($1); }
  | tokVariable tokImgClearBorder { printf("yacc: ImgClearBorder '%s'\n",$1); ImgClearBorder(images[indexOfImage($1)]); }
  | tokVariable tokImgEqual tokParam { printf("yacc: ImgEqual '%s','%s' = %s\n",$1,$3,ImgEqual(images[indexOfImage($1)],images[indexOfImage($3)]) ? "vrai" : "faux"); }
  | tokVariable tokImgNot  { printf("yacc: ImgNot '%s'\n",$1); ImgNot(images[indexOfImage($1)]); }
  | tokVariable tokImgBitNot  { printf("yacc: ImgBitNot '%s'\n",$1); ImgBitNot(images[indexOfImage($1)]); }
  | tokVariable tokImgAnd tokParam { printf("yacc: tokImgAnd '%s','%s'\n",$1,$3); ImgAnd(images[indexOfImage($1)],images[indexOfImage($3)]); }
  | tokVariable tokImgBitAnd tokParam { printf("yacc: ImgBitAnd '%s','%s'\n",$1,$3); ImgBitAnd(images[indexOfImage($1)],images[indexOfImage($3)]); }
  | tokVariable tokImgOr tokParam { printf("yacc: ImgOr '%s','%s'\n",$1,$3); ImgOr(images[indexOfImage($1)],images[indexOfImage($3)]); }
  | tokVariable tokImgBitOr tokParam { printf("yacc: ImgBitOr '%s','%s'\n",$1,$3); ImgBitOr(images[indexOfImage($1)],images[indexOfImage($3)]); }
  | tokVariable tokImgCountObjects { printf("il y a %d objets dans '%s'\n",ImgCountObjects(images[indexOfImage($1)]),$1); }
  | tokVariable tokImgThin  { printf("yacc: ImgThin '%s'\n",$1); ImgThin(images[indexOfImage($1)]); }
  | tokVariable tokImgThicken  { printf("yacc: ImgThicken '%s'\n",$1); ImgThicken(images[indexOfImage($1)]); }
  | tokVariable tokImgThinSkeleton  { printf("yacc: ImgThinSkeleton '%s'\n",$1); ImgThinSkeleton(images[indexOfImage($1)]); }
  ;

%%

int yywrap()
{
  return 1;
}

int yyerror(char *texte)
{
  printf("error: %s\n",texte);
  return -1;
}
